// #autoload
// #name = Auto Demo Namer
// #version = 1.6
// #date = 12/9/2003
// #status = release
// #author = -Wolverine
// #warrior = -Wolverine
// #email = joshua.ross@intec.us
// #web = http://www.steelmaelstrom.com
// #description = Automatically names your demos in a nice format.
// #category = Demo Scripts
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs
// #include = support/team_tracker.cs
// #credit = RedFox, Grinder, Yogi, Sonic

$AutoDemo::starttime[0]=0;
$AutoDemo::starttime[1]=5;
$AutoDemo::starttime[2]=10;
$AutoDemo::starttime[3]=15;
$AutoDemo::starttime[4]=20;
$AutoDemo::starttime[5]=25;
$AutoDemo::starttime[6]=30;
$AutoDemo::count = 7;

package AutoDemoNames {


// -- Grinders Auto demo part --

	function AutoDemoCheck(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)	
	{
		%msgString = getsubstr(detag(%msgString), 1, 39);
		if(%msgString $= "The Admin has switched the server to To")
			$AutoDemo::TourneyMode = true;
		else if(%msgSTring $= "The Admin has switched the server to Ma")
			$AutoDemo::TourneyMode = true;
		else if(%msgString $= "The Admin has switched the server to Fr") 
		{
			$AutoDemo::TourneyMode = false;
			stopDemoRecord();
		}
		%msgString = getsubstr(%msgString, 1, 21);
		if(%msgString $= "Server switched to To")
			$AutoDemo::TourneyMode = true;
		if(%msgString $= "Server switched to Ma")
			$AutoDemo::TourneyMode = true;
		if(%msgString $= "Server switched to Fr")
			$AutoDemo::TourneyMode = false;
	}

	function AutoDemoStart(%a1, %a2) 
	{
		%a2 = detag(%a2);
		%time =  30 - $AutoDemo::starttime[$AutoPref::DemoNames::StartTime];
		%time = %time * 1000;
		if(($AutoDemo::TourneyMode) && (getsubstr(%a2, 1, 26) $= "Match starts in 30 seconds") && ($AutoPref::DemoNames::AutoRecord) && !isRecordingDemo())
			schedule(%time, 0, goDemoGoDemoGo);

	}
 
	function goDemoGoDemoGo() 
	{
		schedule(1000, 0, beginDemoRecord);
	}

	function AutoDemoStop()	
	{
		if(($AutoDemo::TourneyMode) && ($AutoPref::DemoNames::AutoRecord)) 
		{
			schedule(8000, 0, stopDemoRecord);
		}
	}
 
	function clientCmdBottomPrint( %message, %time, %lines )  
	{ 
		// time is specified in seconds
		if (strstr(%message, "Server is Running in To") != -1) 
		{
			$AutoDemo::TourneyMode = true;
		}
		parent::clientCmdBottomPrint(%message, %time, %lines);
	}


	function beginDemoRecord() 
	{
		if(isDemo()) return;
		stopDemoRecord();
		
		///////////////////////////////////////////////////////////////////////		
		// Creating demoname
		%demoname = "";

		// Attempt to derive the Opponents(enemy) Tribal Tag
		//
		for (%i=0; true; %i++)
		{
			%p = PlayerList.findByIndex (%i);
			if (%p == $PLAYER_ERROR)
				break;

			//echo ("name = "@%p.name);
			%name = %p.name;
			%teamid = %p.teamId;

			// Get starting position of tag
			%pos1 = strstr (%name, "\c6");
			if (%pos1 > 0)
			{
				// Get ending position of tag
				%pos2 = strstr (%name, "\c7");
				if (%pos2 < %pos1)
				{
					//echo ("Here 1");
					%tag = getSubStr (%name, %pos2 + 1, %pos1 - %pos2 - 1);
				}
				else
				{
					//echo ("Here 2");
					%pos3 = strstr (%name, "\x11");
					%tag = getSubStr (%name, %pos2+1, %pos3 - %pos2 - 1);
				}
			}

			if (%tag !$= "")
			{
				// Accumulate the tag counts
				%tagCounts[%teamid, %tag]++;
				if (%tagCounts[%teamid, %tag] > %bestTagCount[%teamid])
				{
					// These are the max winners
					%bestTagCount[%teamid] = %tagCounts[%teamid, %tag];
					%bestTag[%teamid] = %tag;
				}
				//echo ("name = "@%name@", Tag = "@%tag);
			}
		}

		// Get the respective team Id's
		%myTeamId = PlayerList.getTeamByName (PlayerList.getMyName());
		%enemyTeamId = (%myTeamId == 1) ? 2 : 1;
				
		//Friendly Tribal Tag
		%myTag = getField (wonGetAuthInfo(), 1);
		if (%myTag $= "")
			%ttag = "unknowntag";
		else
			%ttag = %myTag;
		
		//%ttag = (%myTag $= "") : "unknowntag" : %myTag;
		
		//Opponents(enemy) Tribal Tag
		// If number of players is less than 4 then set tag as unknowntag	
		%otag = (%bestTagCount[%enemyTeamId] < 3) ? "unknowntag" : %bestTag[%enemyTeamId];
		
		//Ladder Name
		%ltag = "";
		%ltag = $AutoPref::DemoNames::Ladder;
		
		//Mission Name
		%mname = strreplace($MissionName, "'", ""); %mname = strreplace(%mname, " ", "");
		if (%mname $= "") 
		{
			%mname = "unknownmap";
		}

		
		//Player Name
		%pname = getField( $pref::Player[$pref::Player::Current], 0 );

		//////////////////////////////////////////////////////////////////////////
		//Concatenate the Demo Name
		//
		//If we have the ladder tag inlude it in the string that is the demo name
		if( %ltag $= "")
		{
			%demoname = %ttag @ "_vs_" @ %otag @ "-" @ %mname @ "-" @ %pname;
		}
		else
		{
			%demoname = "(" @ %ltag @ ")" @ %ttag @ "_vs_" @ %otag @ "-" @ %mname @ "-" @ %pname;
		}
		
		// Cleaning demoname of illegal characters
		for(%i = 0; (%char = getSubStr(%demoname, %i, 1)) !$= ""; %i++) {
			switch$(%char) {
			case "/" :
				echo("Illegal character in filename");
			case ":" :
				echo("Illegal character in filename");
			case "*" :
				echo("Illegal character in filename");
			case "?" :
				echo("Illegal character in filename");
			case "<" :
				echo("Illegal character in filename");
			case ">" :
				echo("Illegal character in filename");
			case "|" :
				echo("Illegal character in filename");
			case " " :
				echo("Illegal character in filename");
			default:
				%cleanname = %cleanname @ %char;
			}
		}

		// Creating full filename
		$DemoCount = 0;
		//%date = date("mdy");
		%date = formatTimeString("mmddy");
		for(%found = true; %found; $DemoCount++ ) 
		{
			%suffix = $DemoCount;
			if($DemoCount == 0) %suffix = "";
			%file = "recordings/" @ %date @ "-" @ %cleanname @ %suffix @ ".rec";
			%found = isFile(%file);
		}

		$DemoFile=%file;
		addMessageHudLine( "\c4Recording to file [\c2" @ $DemoFile @ "\cr].");
		saveDemoSettings();
		startRecord(%file);

		if(!isRecordingDemo()) 
		{
			deleteFile($DemoFile);
			addMessageHudLine( "\c3 *** Failed to record to file [\c2" @ $DemoFile @ "\cr].");
			$DemoFile = "";
		}
  
		if ($AutoPref::DemoNames::RecHud) 
		{
			//PlayGui.remove(AutoDemoHud);
			PlayGui.add(AutoDemoRecHud);
			AutoDemoHudText.setText("Rec");
			%xpos = firstWord(MainChatHud.position) + 5;
			%ypos = getWord(MainChatHud.position, 1);
			%ypos +=   getWord( OuterChatHud.extent, 1 )+10;
			AutoDemoHudText.position = %xpos SPC %ypos;
			echo(AutoDemoText.position);
			AutoDemoHudText.Visible = 1;
			AutoDemoHudText.setVisible(true);
		}

	}

	function stopDemoRecord() 
	{
		parent::stopDemoRecord();
		PlayGui.remove(AutoDemoRecHud);
	}

	function AutoDemoNamesStop() 
	{
		canvas.popDialog(AutoDemoNamesDlg);
		stopDemoRecord();

	}

	function AutoDemoNamesStart() 
	{
		canvas.popDialog(AutoDemoNamesDlg);
		beginDemoRecord();
	}

	function AutoDemoNamesOptionsOpen(%val) 
	{
		if (%val) 
		{
			canvas.pushDialog(AutoDemoNamesDlg);
		}
	}



	function DispatchLaunchMode() 
	{
		makeTracker();                                          // -- Initialise UberGuy's Teamtracker
		addMessageCallback('MsgAdminForce', AutoDemoCheck);     // -- Initialise Grinder's Autodemo
		addMessageCallback('MsgVotePassed', AutoDemoCheck);
		addMessageCallback('MsgMissionStart', AutoDemoStart);
		addMessageCallback('MsgGameOver', AutoDemoStop);
		parent::DispatchLaunchMode();
	}
    
   	function OptionsDlg::onWake(%this) 
	{
		if(!$AutoDemoNamesBind) 
		{
			$RemapName[$RemapCount]="AutoDemoNames Options";
			$RemapCmd[$RemapCount]="AutoDemoNamesOptionsOpen";
			$RemapCount++;
			$AutoDemoNamesBind = true;
		}
		parent::onWake(%this);
	}



	function AutoDemoNamesSave() 
	{
		export("$AutoPref::*", "prefs/AutoPrefs.cs", false);
	}


	// This is from Halide's
	function quit() 
	{
		// If not saved already (can be done from another script)
		if(!$AutoPrefsSaved) 
		{
			// Save the prefs to a file
			export("$AutoPref::*", "prefs/AutoPrefs.cs", false);
			// Set the pref that says so
			$AutoPrefsSaved = true;
		}
		parent::quit();
	}


	function AutoDemoNamesDlg::onWake(%this) 
	{
		AutoDemoStartTime.clear();
		for (%x=0; %x < $AutoDemo::count; %x ++) 
		{
			AutoDemoStartTime.add($AutoDemo::starttime[%x] @ " seconds", %x );
		}
		AutoDemoStartTime.setSelected($AutoPref::DemoNames::StartTime);
	}

	function AutoDemoNamesDlg::onSleep(%this) 
	{
		$AutoPref::DemoNames::StartTime = AutoDemoStartTime.getSelected();
	}

};

activatePackage(AutoDemoNames);

if(isFile("prefs/AutoPrefs.cs") && !$AutoPrefsLoaded) 
{
		exec("prefs/AutoPrefs.cs");
		$AutoPrefsLoaded = true;
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(AutoDemoNamesDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
		pane = "Options";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "109 91";
		extent = "500 255";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "DEMO NAME OPTIONS";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellTabButton(redDemoNamesOptionsTab) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 40";
			extent = "120 40";
			minExtent = "48 38";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "redDemoNamesDlg.setPane(Options);";
			helpTag = "0";
			text = "Options";
			longTextBuffer = "0";
			maxLength = "255";
				simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "26 78";
			extent = "120 40";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "canvas.popDialog(AutoDemoNamesDlg);";
			accelerator = "escape";
			helpTag = "0";
			text = "Done";
			simpleStyle = "0";
		};
		new ShellFieldCtrl(redDemoNamesOptions) {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "143 38";
			extent = "335 193";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellTextEditCtrl() {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "170 39";
				extent = "149 40";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$AutoPref::DemoNames::Ladder";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "28 150";
				extent = "140 40";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "AutoDemoNamesStart();";
				helpTag = "0";
				text = "Record";
				simpleStyle = "0";
			};
			new GuiTextCtrl() {
				profile = "GuiChatHudProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 14";
				extent = "90 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Opponents Tag";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellTextEditCtrl() {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "170 6";
				extent = "149 40";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$AutoPref::DemoNames::OppTag";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			new GuiTextCtrl() {
				profile = "GuiChatHudProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "24 46";
				extent = "40 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Ladder";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "175 150";
				extent = "140 40";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "AutoDemoNamesStop();";
				helpTag = "0";
				text = "Stop";
				simpleStyle = "0";
			};
			new ShellToggleButton() {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "32 110";
				extent = "129 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$AutoPref::DemoNames::AutoRecord";
				helpTag = "0";
				text = "Auto Start Record";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellPopupMenu(AutoDemoStartTime) {
				profile = "ShellPopupProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "177 105";
				extent = "141 36";
				minExtent = "49 36";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				maxPopupHeight = "200";
				buttonBitmap = "gui/shll_pulldown";
				rolloverBarBitmap = "gui/shll_pulldownbar_rol";
				selectedBarBitmap = "gui/shll_pulldownbar_act";
				noButtonStyle = "0";
			};
			new ShellToggleButton() {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "32 80";
				extent = "129 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$AutoPref::DemoNames::RecHud";
				helpTag = "0";
				text = "Show Recording Hud";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "27 39";
			extent = "120 40";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "AutoDemoNamesSave();";
			helpTag = "0";
			text = "Save";
			simpleStyle = "0";
		};
	};
};
//--- OBJECT WRITE END ---

new GuiControlProfile ("AutoColorProfile") {
    fontType = "Univers";
    fontSize = 14;
    fontColor = "250 000 000";
};


new GuiControl(AutoDemoRecHud) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

         new  GuiTextCtrl(AutoDemoHudText) {
              profile = "AutoColorProfile";
              horizSizing = "right";
              vertSizing = "bottom";
              position = "0 0";
              extent = "60 20";
              minExtent= "8 8";
              visible = "0";
              helpTag = "0";
              lineSpacing = "2";
              allowColorChars = "0";
              text = "";
              maxLenth = "255";
         };
};

